#ifndef GRAFO_H_
#define GRAFO_H_

#include "Lista.h"


template <typename C> class Grafo
{
public:
	class Arco
	{
	public:
		Arco();
		Arco(int adyacente, const C & costo);
		int devolverAdyacente() const;
		const C & devolverCosto() const;
	private:
		int vertice;
		C costo;
	}; // class Arco

public:
	// NOTA: Dependiendo de la implementación puede ser necesario incluir otras funciones constructuras
	Grafo();
	Grafo(const Grafo & otroGrafo);

	~Grafo();

	Grafo & operator = (const Grafo & otroGrafo);

	// Devuelve true si la cantidad de vértices es cero
	bool estaVacio() const;
	// Indica la cantidad de vértices del grafo
	int devolverLongitud() const;

	bool existeVertice(int vertice) const;

	bool existeArco(int origen, int destino) const;

	// PRE CONDICION: existeArco(origen, destino)
	const C & costoArco(int origen, int destino) const;

	void devolverVertices(Lista<int> & vertices) const;

	void devolverAdyacentes(int origen, Lista<Arco> & adyacentes) const;

	void agregarVertice(int vertice);

	// POST CONDICION: Para todo vértice v != vertice: !existeArco(v, vertice) && !existeArco(vertice, v)
	void eliminarVertice(int vertice);

	// PRE CONDICION: existeArco(origen, destino)
	C & costoArco(int origen, int destino);

	// PRE CONDICION: existeVertice(origen) && existeVertice(destino)
	// POST CONDICION: existeArco(origen, destino)
	void agregarArco(int origen, int destino, const C & costo);

	// POST CONDICION: !existeArco(origen, destino)
	void eliminarArco(int origen, int destino);

	void vaciar();

private:
	/*
	 * Definir la estructura interna
	 */

}; // class Grafo


/*
 * Arco
 */

template <typename C> Grafo<C>::Arco::Arco()
{

}

template <typename C> Grafo<C>::Arco::Arco(int adyacente, const C & costo)
{

}

template <typename C> int Grafo<C>::Arco::devolverAdyacente() const
{

}

template <typename C> const C & Grafo<C>::Arco::devolverCosto() const
{

}


/*
 * Grafo
 */

template <typename C> Grafo<C>::Grafo()
{

}

template <typename C> Grafo<C>::Grafo(const Grafo & otroGrafo)
{

}

template <typename C> Grafo<C>::~Grafo()
{

}

template <typename C> Grafo<C> & Grafo<C>::operator = (const Grafo & otroGrafo)
{

}

template <typename C> bool Grafo<C>::estaVacio() const
{

}

template <typename C> int Grafo<C>::devolverLongitud() const
{

}

template <typename C> bool Grafo<C>::existeVertice(int vertice) const
{

}

template <typename C> bool Grafo<C>::existeArco(int origen, int destino) const
{

}

template <typename C> const C & Grafo<C>::costoArco(int origen, int destino) const
{

}

template <typename C> void Grafo<C>::devolverVertices(Lista<int> & vertices) const
{

}

template <typename C> void Grafo<C>::devolverAdyacentes(int origen, Lista<Arco> & adyacentes) const
{

}

template <typename C> void Grafo<C>::agregarVertice(int vertice)
{

}

template <typename C> void Grafo<C>::eliminarVertice(int vertice)
{

}

template <typename C> C & Grafo<C>::costoArco(int origen, int destino)
{

}

template <typename C> void Grafo<C>::agregarArco(int origen, int destino, const C & costo)
{

}

template <typename C> void Grafo<C>::eliminarArco(int origen, int destino)
{

}

template <typename C> void Grafo<C>::vaciar()
{

}

#endif /* GRAFO_H_ */
