#include "Grafo.h"

#include "iostream"

using namespace std;


template <typename C>
ostream & operator << (ostream & salida, const Grafo<C> & grafo)
{
	// Recorremos todos los vertices
	Lista<int> vertices;
	grafo.devolverVertices(vertices);
	Lista<int>::Iterador v = vertices.devolverIterador();
	while (!v.llegoAlFinal()) {
		salida << "    " << v.elementoActual() << "\n";
		// Recorremos todos los adyacentes de cada vertice
		Lista<typename Grafo<C>::Arco> adyacentes;
		grafo.devolverAdyacentes(v.elementoActual(), adyacentes);
		typename Lista<typename Grafo<C>::Arco>::Iterador ady = adyacentes.devolverIterador();
		while (!ady.llegoAlFinal()) {
			salida << "    " << v.elementoActual() << "-> " << ady.elementoActual().devolverAdyacente() << " (" << ady.elementoActual().devolverCosto() << ")\n";
			ady.avanzar();
		}
		v.avanzar();
	}
	return salida;
}


int main(int argc, char **argv)
{
	Grafo<int> g;

	// Cargamos un grafo dirigido
	// Primero los vértices
	g.agregarVertice(1);
	g.agregarVertice(2);
	g.agregarVertice(3);
	g.agregarVertice(4);
	g.agregarVertice(5);
	g.agregarVertice(6);
	g.agregarVertice(7);
	// Luego los arcos
	g.agregarArco(1, 2, 1);
	g.agregarArco(1, 3, 1);
	g.agregarArco(1, 4, 1);
	g.agregarArco(2, 6, 2);
	g.agregarArco(3, 5, 3);
	g.agregarArco(4, 7, 4);
	g.agregarArco(5, 6, 5);

	// Mostramos el grafo
	cout << "Estructura del grafo:\n" << g << "\n";

	return 0;
}
